(* ------------------------------------------------------ *)
(*                      G_INIT.PAS                        *)
(*     Initialisierung der Unit MOUSE (TOOLBOX 3'89)      *)
(*                fr Hercules-Grafikkarte                *)
(*         (c) 1989  Maximilian Mayr  &  TOOLBOX          *)
(* ------------------------------------------------------ *)
UNIT G_Init;

INTERFACE

USES Crt, Dos, Graph;

PROCEDURE Init_Graphic;

IMPLEMENTATION

  PROCEDURE Init_Graphic;

  VAR
    GraphDriver, GraphMode : INTEGER;
    ErrorCode              : INTEGER;
  BEGIN
    DetectGraph(GraphDriver, GraphMode);
    IF GraphDriver = CGA THEN
      GraphMode := CGAHi
    ELSE
      IF GraphDriver = HercMono THEN BEGIN
        Mem [$40:$49] := 6;
        GraphMode := HercMonoHi;
      END ELSE
        GraphDriver := Detect;
    InitGraph(GraphDriver, GraphMode, '');
    ErrorCode := GraphResult;
    IF ErrorCode <> 0 THEN BEGIN
      WriteLn('Grafik-Fehler: ', GraphErrorMsg(ErrorCode));
      WriteLn('Programm abgebrochen ...');
      Halt(1);
    END;
  END;

END.
(* ------------------------------------------------------ *)
(*                 Ende von G_Init.PAS                    *)